$(function(){
var rangeSelector = $("#range-selector").dxRangeSelector({
margin: {
top: 50
},
scale: {
startValue: new Date(2011, 0, 1),
endValue: new Date(2011, 11, 31),
minorTickInterval: "day",
tickInterval: "month",
minorTick: {
visible: false,
},
marker: { visible: false },
label: {
format: "MMM"
}
},
behavior: {
callValueChanged: "onMoving"
},
sliderMarker: {
format: "dd EEEE"
},
title: "Calculate the Working Days Count in a Date Period",
onValueChanged: function (e) {
var currentDate = new Date(e.value[0]),
workingDaysCount = 0;
while (currentDate <= e.value[1]) {
if(currentDate.getDay() > 0 && currentDate.getDay() < 6) {
workingDaysCount++;
}
currentDate.setDate(currentDate.getDate() + 1);
}
$("#workingDaysCount").html(workingDaysCount.toFixed());
}
}).dxRangeSelector("instance");
$("#handle").dxSelectBox({
dataSource: ["onMoving", "onMovingComplete"],
width: 210,
value: "onMoving",
onValueChanged: function (data) {
rangeSelector.option("behavior.callValueChanged",data.value);
}
});
});
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0" />
<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
<script>window.jQuery || document.write(decodeURIComponent('%3Cscript src="js/jquery.min.js"%3E%3C/script%3E'))</script>
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/20.2.6/css/dx.common.css" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/20.2.6/css/dx.light.css" />
<script src="https://cdn3.devexpress.com/jslib/20.2.6/js/dx.all.js"></script>
<link rel="stylesheet" type="text/css" href="styles.css" />
<script src="index.js"></script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="range-selector-demo">
<div id="range-selector"></div>
<h2>Working days count: <span id="workingDaysCount">260</span></h2>
<div class="options">
<div class="caption">Options</div>
<div class="option">
<span>Handle Range Changes</span>
<div id="handle"></div>
</div>
</div>
</div>
</div>
</body>
</html>
#range-selector {
height: 200px;
}
h2 {
text-align: center;
}
.options {
padding: 20px;
background-color: rgba(191, 191, 191, 0.15);
position: absolute;
bottom: 0;
left: 0;
right: 0;
}
.option {
margin-top: 10px;
}
.caption {
font-size: 18px;
font-weight: 500;
}
.option > span {
margin-right: 10px;
}
.option > .dx-widget {
display: inline-block;
vertical-align: middle;
}

import React from 'react';
import RangeSelector, { Margin, Scale, MinorTick, Marker, Label, Behavior, SliderMarker } from 'devextreme-react/range-selector';
import { SelectBox } from 'devextreme-react/select-box';
const startValue = new Date(2011, 0, 1);
const endValue = new Date(2011, 11, 31);
const behaviorModes = ['onMoving', 'onMovingComplete'];
class App extends React.Component {
constructor(props) {
super(props);
this.state = {
workingDaysCount: calculateWorkdays([startValue, endValue]),
behaviorMode: behaviorModes[0]
};
this.processRange = this.processRange.bind(this);
this.setBehavior = this.setBehavior.bind(this);
}
render() {
return (
<div id="range-selector-demo">
<RangeSelector
id="range-selector"
title="Calculate the Working Days Count in a Date Period"
onValueChanged={this.processRange}
>
<Margin top={50} />
<Scale startValue={startValue} endValue={endValue} minorTickInterval="day" tickInterval="month">
<MinorTick visible={false} />
<Marker visible={false} />
<Label format="MMM" />
</Scale>
<Behavior callValueChanged={this.state.behaviorMode} />
<SliderMarker format="dd EEEE" />
</RangeSelector>
<h2>Working days count: { this.state.workingDaysCount }</h2>
<div className="options">
<div className="caption">Options</div>
<div className="option">
<span>Handle Range Changes </span>
<SelectBox
dataSource={behaviorModes}
width={210}
value={this.state.behaviorMode}
onValueChanged={this.setBehavior}
/>
</div>
</div>
</div>
);
}
processRange(e) {
this.setState({
workingDaysCount: calculateWorkdays(e.value)
});
}
setBehavior(data) {
this.setState({
behaviorMode: data.value
});
}
}
function calculateWorkdays([start, end]) {
const currentDate = new Date(start);
let workingDaysCount = 0;
while (currentDate <= end) {
if (currentDate.getDay() > 0 && currentDate.getDay() < 6) {
workingDaysCount++;
}
currentDate.setDate(currentDate.getDate() + 1);
}
return workingDaysCount;
}
export default App;
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.js';
ReactDOM.render(
<App />,
document.getElementById('app')
);
<!DOCTYPE html>
<html>
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/20.2.4/css/dx.common.css" />
<link rel="dx-theme" data-theme="generic.light" href="https://cdn3.devexpress.com/jslib/20.2.4/css/dx.light.css" />
<link rel="stylesheet" type ="text/css" href="styles.css" />
<script src="https://unpkg.com/core-js@2.4.1/client/shim.min.js"></script>
<script src="https://unpkg.com/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import('./index.js');
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"></div>
</div>
</body>
</html>
#range-selector {
height: 200px;
}
h2 {
text-align: center;
}
.options {
padding: 20px;
background-color: rgba(191, 191, 191, 0.15);
position: absolute;
bottom: 0;
left: 0;
right: 0;
}
.option {
margin-top: 10px;
}
.caption {
font-size: 18px;
font-weight: 500;
}
.option > span {
margin-right: 10px;
}
.option > .dx-widget {
display: inline-block;
vertical-align: middle;
}
System.config({
transpiler: 'plugin-babel',
meta: {
},
paths: {
'npm:': 'https://unpkg.com/'
},
defaultExtension: 'js',
map: {
'react': 'npm:react@16.14.0/umd/react.development.js',
'react-dom': 'npm:react-dom@16.14.0/umd/react-dom.development.js',
'prop-types': 'npm:prop-types@15.7.2/prop-types.js',
'rrule': 'npm:rrule@2.6.6/dist/es5/rrule.js',
'luxon': 'npm:luxon@1.25.0/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign@1.1.0',
'devextreme': 'npm:devextreme@20.2.4',
'devextreme-react': 'npm:devextreme-react@20.2.4',
'jszip': 'npm:jszip@3.5.0/dist/jszip.min.js',
'devextreme-quill': 'npm:devextreme-quill@0.9.7/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.0.5/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@2.0.8/dist/dx-gantt.js',
'preact': 'npm:preact@10.5.7/dist/preact.js',
'preact/hooks': 'npm:preact@10.5.7/hooks/dist/hooks.js',
// SystemJS plugins
'plugin-babel': 'npm:systemjs-plugin-babel@0.0.25/plugin-babel.js',
'systemjs-babel-build': 'npm:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js'
},
packages: {
'devextreme': {
defaultExtension: 'js'
},
'devextreme-react': {
main: 'index.js'
},
'devextreme/events/utils': {
main: 'index'
},
'devextreme/events': {
main: 'index'
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js'
}
},
babelOptions: {
sourceMaps: false,
stage0: true,
react: true
}
});

<template>
<div>
<div id="range-selector-demo">
<DxRangeSelector
id="range-selector"
v-model:value="range"
title="Calculate the Working Days Count in a Date Period"
>
<DxMargin :top="50"/>
<DxScale
:start-value="startValue"
:end-value="endValue"
tick-interval="month"
minor-tick-interval="day"
>
<DxMinorTick :visible="false"/>
<DxMarker :visible="false"/>
<DxLabel format="MMM"/>
</DxScale>
<DxBehavior :call-value-changed="currentBehaviorMode"/>
<DxSliderMarker format="dd EEEE"/>
</DxRangeSelector>
<h2>Working days count: {{ workingDaysCount }}</h2>
<div class="options">
<div class="caption">Options</div>
<div class="option">
<span>Handle Range Changes </span>
<DxSelectBox
:data-source="behaviorModes"
:width="210"
v-model:value="currentBehaviorMode"
/>
</div>
</div>
</div>
</div>
</template>
<script>
import {
DxRangeSelector,
DxMargin,
DxScale,
DxMinorTick,
DxMarker,
DxLabel,
DxBehavior,
DxSliderMarker,
} from 'devextreme-vue/range-selector';
import { DxSelectBox } from 'devextreme-vue/select-box';
export default {
components: {
DxRangeSelector,
DxMargin,
DxScale,
DxMinorTick,
DxMarker,
DxLabel,
DxBehavior,
DxSliderMarker,
DxSelectBox,
},
data() {
const range = [new Date(2011, 0, 1), new Date(2011, 11, 31)];
const behaviorModes = ['onMoving', 'onMovingComplete'];
return {
startValue: range[0],
endValue: range[1],
range,
behaviorModes,
currentBehaviorMode: behaviorModes[0],
};
},
computed: {
workingDaysCount() {
const currentDate = new Date(this.range[0]);
let workingDaysCount = 0;
while (currentDate <= this.range[1]) {
if (currentDate.getDay() > 0 && currentDate.getDay() < 6) {
workingDaysCount += 1;
}
currentDate.setDate(currentDate.getDate() + 1);
}
return workingDaysCount;
},
},
};
</script>
<style scoped>
#range-selector {
height: 200px;
}
h2 {
text-align: center;
}
.options {
padding: 20px;
background-color: rgba(191, 191, 191, 0.15);
position: absolute;
bottom: 0;
left: 0;
right: 0;
}
.option {
margin-top: 10px;
}
.caption {
font-size: 18px;
font-weight: 500;
}
.option > span {
margin-right: 10px;
}
.option > .dx-widget {
display: inline-block;
vertical-align: middle;
}
</style>
import { createApp } from 'vue';
import App from './App.vue';
createApp(App).mount('#app');
<!DOCTYPE html>
<html>
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/22.1.4/css/dx.common.css" />
<link rel="dx-theme" data-theme="generic.light" href="https://cdn3.devexpress.com/jslib/22.1.4/css/dx.light.css" />
<script src="https://unpkg.com/core-js@2.4.1/client/shim.min.js"></script>
<script src="https://unpkg.com/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.js");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"> </div>
</div>
</body>
</html>
window.config = {
transpiler: 'plugin-babel',
meta: {
'*.vue': {
loader: 'vue-loader',
},
'devextreme/localization.js': {
'esModule': true,
},
},
paths: {
'npm:': 'https://unpkg.com/',
},
map: {
'vue': 'npm:vue@3.0.0/dist/vue.esm-browser.js',
'vue-loader': 'npm:dx-systemjs-vue-browser@1.0.15/index.js',
'mitt': 'npm:mitt/dist/mitt.umd.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@1.28.0/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign@1.1.0',
'devextreme': 'npm:devextreme@22.1.4/cjs',
'devextreme-vue': 'npm:devextreme-vue@22.1.4',
'jszip': 'npm:jszip@3.7.1/dist/jszip.min.js',
'devextreme-quill': 'npm:devextreme-quill@1.5.16/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.1.63/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.32/dist/dx-gantt.js',
'@devextreme/runtime': 'npm:@devextreme/runtime@3.0.7',
'inferno': 'npm:inferno@7.4.4/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat@7.4.11/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@7.4.11/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate@7.4.11/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode@7.4.11/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class@7.4.11/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras@7.4.11/dist/inferno-extras.min.js',
'plugin-babel': 'npm:systemjs-plugin-babel@0.0.25/plugin-babel.js',
'systemjs-babel-build': 'npm:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js',
},
packages: {
'devextreme-vue': {
main: 'index.js',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
'npm:@devextreme/runtime@3.0.7/inferno/package.json',
],
babelOptions: {
sourceMaps: false,
stage0: true,
},
};
System.config(window.config);

<div id="range-selector-demo">
<dx-range-selector
id="range-selector"
title="Calculate the Working Days Count in a Date Period"
(onValueChanged)="onValueChanged($event)"
>
<dxo-margin [top]="50"></dxo-margin>
<dxo-scale
[startValue]="startValue"
[endValue]="endValue"
minorTickInterval="day"
tickInterval="month"
>
<dxo-minor-tick [visible]="false"></dxo-minor-tick>
<dxo-marker [visible]="false"></dxo-marker>
<dxo-label [customizeText]="customizeLabel"></dxo-label>
</dxo-scale>
<dxo-slider-marker [customizeText]="customizeSliderMarker">
</dxo-slider-marker>
<dxo-behavior #beh callValueChanged="onMoving"> </dxo-behavior>
</dx-range-selector>
<h2>Working days count: {{ workingDaysCount.toFixed() }}</h2>
<div class="options">
<div class="caption">Options</div>
<div class="option">
<span>Handle Range Changes</span>
<dx-select-box
id="handle"
[dataSource]="dataSource"
[width]="210"
[(value)]="beh.callValueChanged"
></dx-select-box>
</div>
</div>
</div>
import { NgModule, Component, enableProdMode } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { DatePipe } from '@angular/common';
import { platformBrowserDynamic } from '@angular/platform-browser-dynamic';
import { DxRangeSelectorModule, DxSelectBoxModule } from 'devextreme-angular';
if (!/localhost/.test(document.location.host)) {
enableProdMode();
}
@Component({
selector: 'demo-app',
templateUrl: 'app/app.component.html',
styleUrls: ['app/app.component.css'],
preserveWhitespaces: true,
})
export class AppComponent {
pipe: any = new DatePipe('en-US');
dataSource: string[] = ['onMoving', 'onMovingComplete'];
workingDaysCount = 260;
startValue: Date = new Date(2011, 0, 1);
endValue: Date = new Date(2011, 11, 31);
onValueChanged = (e) => {
const currentDate = new Date(e.value[0]);
let workingDaysCount = 0;
while (currentDate <= e.value[1]) {
if (currentDate.getDay() > 0 && currentDate.getDay() < 6) {
workingDaysCount++;
}
currentDate.setDate(currentDate.getDate() + 1);
}
this.workingDaysCount = workingDaysCount;
};
customizeSliderMarker = (data) => this.pipe.transform(data.value, 'dd EEEE');
customizeLabel = (data) => this.pipe.transform(data.value, 'MMM');
}
@NgModule({
imports: [
BrowserModule,
DxRangeSelectorModule,
DxSelectBoxModule,
],
declarations: [AppComponent],
bootstrap: [AppComponent],
})
export class AppModule { }
platformBrowserDynamic().bootstrapModule(AppModule);
::ng-deep #range-selector {
height: 200px;
}
::ng-deep h2 {
text-align: center;
}
::ng-deep .options {
padding: 20px;
background-color: rgba(191, 191, 191, 0.15);
position: absolute;
bottom: 0;
left: 0;
right: 0;
}
::ng-deep .option {
margin-top: 10px;
}
::ng-deep .caption {
font-size: 18px;
font-weight: 500;
}
::ng-deep .option > span {
margin-right: 10px;
}
::ng-deep .option > .dx-widget {
display: inline-block;
vertical-align: middle;
}
// In real applications, you should not transpile code in the browser.
// You can see how to create your own application with Angular and DevExtreme here:
// https://js.devexpress.com/Documentation/Guide/Angular_Components/Getting_Started/Create_a_DevExtreme_Application/
window.config = {
transpiler: 'ts',
typescriptOptions: {
module: 'system',
emitDecoratorMetadata: true,
experimentalDecorators: true,
},
meta: {
'typescript': {
'exports': 'ts',
},
'devextreme/localization.js': {
'esModule': true,
},
},
paths: {
'npm:': 'https://unpkg.com/',
},
map: {
'ts': 'npm:plugin-typescript@4.2.4/lib/plugin.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'@angular/core': 'npm:@angular/core@12.2.16',
'@angular/platform-browser': 'npm:@angular/platform-browser@12.2.16',
'@angular/platform-browser-dynamic': 'npm:@angular/platform-browser-dynamic@12.2.16',
'@angular/forms': 'npm:@angular/forms@12.2.16',
'@angular/common': 'npm:@angular/common@12.2.16',
'@angular/compiler': 'npm:@angular/compiler@12.2.16',
'tslib': 'npm:tslib@2.3.1/tslib.js',
'rxjs': 'npm:rxjs@7.5.3/dist/bundles/rxjs.umd.js',
'rxjs/operators': 'npm:rxjs@7.5.3/dist/cjs/operators/index.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@1.28.0/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign@1.1.0',
'devextreme': 'npm:devextreme@22.1.3/cjs',
'devextreme/bundles/dx.all': 'npm:devextreme@22.1.3/bundles/dx.all.js',
'jszip': 'npm:jszip@3.7.1/dist/jszip.min.js',
'devextreme-quill': 'npm:devextreme-quill@1.5.16/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.1.57',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.30',
'devextreme-angular': 'npm:devextreme-angular@22.1.3',
'@devextreme/runtime': 'npm:@devextreme/runtime@3.0.7',
'inferno': 'npm:inferno@7.4.4/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat@7.4.11/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@7.4.11/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate@7.4.11/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode@7.4.11/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class@7.4.11/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras@7.4.11/dist/inferno-extras.min.js',
},
packages: {
'app': {
main: './app.component.ts',
defaultExtension: 'ts',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
'rxjs': {
defaultExtension: 'js',
},
'rxjs/operators': {
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
'npm:@devextreme/runtime@3.0.7/inferno/package.json',
'npm:@angular/*/package.json',
'npm:@angular/common@12.2.16/*/package.json',
'npm:rxjs@7.5.3/package.json',
'npm:rxjs@7.5.3/operators/package.json',
'npm:devextreme-angular@22.1.3/*/package.json',
'npm:devextreme-angular@22.1.3/ui/*/package.json',
'npm:devextreme-angular@22.1.3/package.json',
'npm:devexpress-diagram@2.1.57/package.json',
'npm:devexpress-gantt@4.1.30/package.json',
],
};
System.config(window.config);
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/22.1.3/css/dx.common.css" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/22.1.3/css/dx.light.css" />
<script src="https://unpkg.com/core-js@2.4.1/client/shim.min.js"></script>
<script src="https://unpkg.com/zone.js@0.11.4/dist/zone.js"></script>
<script src="https://unpkg.com/reflect-metadata@0.1.3/Reflect.js"></script>
<script src="https://unpkg.com/systemjs@0.21.3/dist/system.js"></script>
<script src="config.js"></script>
<script>
System.import("app").catch(console.error.bind(console));
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<demo-app>Loading...</demo-app>
</div>
</body>
</html>